<?php
/**
 * @project Astra.CMS
 * @link http://a-cms.ru/
 * @copyright 2011 " "
 * @author Vitaly Hohlov <admin@a-cms.ru>
 * @package Plugins
 */
/**************************************************************************/

function discount_getGroup()
{
  if($structure=getStructureByPlugin("groups"))
  { if(A::$AUTH->isLogin())
    { if(A::$AUTH->data['idgroup']>0)
	  return A::$AUTH->data['idgroup'];
	  else
	  return A::$DB->getOne("SELECT id FROM {$structure} WHERE idsec>0 ORDER BY sort LIMIT 0,1");
    }
	else
	return A::$DB->getOne("SELECT id FROM {$structure} WHERE idsec=0");
  }
  else
  return 0;
}

function discount_prepareValues($section,$data)
{ static $structure=null;
  static $sumorders=null;
  static $vars=null;
  static $discount=array();

  if((!in_array(A::$MAINFRAME->page,array('basket','order')) || !empty(A::$MAINFRAME->_tpl_vars['system'])) && empty($data['basketblock']))
  return $data;

  if(is_null($structure))
  $structure=getStructureByPlugin('discount');

  if(empty($data['oldprice']))
  $data['oldprice']=$data['price'];

  if(!empty($data['mprices']))
  foreach($data['mprices'] as $i=>$mp)
  if(empty($mp['oldprice']))
  $data['mprices'][$i]['oldprice']=$mp['price'];

  $dec=getOption($structure,'dec');

  //--

  if(is_null($vars))
  { $date=time();
    $vars=A::$DB->getAll("
    SELECT * FROM {$structure}
    WHERE type='var' AND (date='N' OR (date='Y' AND date1<={$date} AND date2>={$date})) AND active='Y'
    ORDER BY discount DESC");
    foreach($vars as $i=>$row)
    $vars[$i]['rules']=unserialize($row['rules']);
  }

  $vdiscount=0;

  foreach($vars as $i=>$row)
  {
	$f=true;
    foreach($row['rules']['vars'] as $field=>$value)
	$f = $f && isset($data[$field]) && trim($data[$field])==trim($value);

	if($f)
    { $vdiscount=$row['discount'];
      break;
    }
  }

  if($vdiscount)
  {
    $data['oldprice']=$data['price'];
    $data['discountpr']=$vdiscount;
    $data['discount']=round($data['price']*$vdiscount/100,$dec);
	$data['price']=$data['price']-$data['discount'];

    if(!empty($data['mprices']))
    foreach($data['mprices'] as $i=>$mp)
    { $data['mprices'][$i]['oldprice']=$mp['price'];
	  $data['mprices'][$i]['discountpr']=$vdiscount;
	  $data['mprices'][$i]['discount']=round($mp['price']*$vdiscount/100,$dec);
	  $data['mprices'][$i]['price']=$mp['price']-$data['mprices'][$i]['discount'];
    }

    return $data;
  }

  //--

  if(is_null($sumorders) && A::$AUTH->isLogin())
  $sumorders=(integer)A::$DB->getOne("SELECT SUM(sum) FROM {$section}_orders WHERE iduser=".A::$AUTH->id." AND status>0");

  if(!isset($discount[$data['idcat']]))
  {
	$basket=A_Session::get("shoplite_basket",array());
	if(empty($basket)) $basket=array();

	$allsum=0;
	foreach($basket as $row)
	{ $sum=$row['data']['price']*$row['count'];
	  $allsum+=$sum;
	}

	$date=time();

	$discount1=!empty($sumorders)?(float)A::$DB->getOne("
	SELECT discount FROM {$structure}
	WHERE type='all' AND sum<={$sumorders} AND (date='N' OR (date='Y' AND date1<={$date} AND date2>={$date})) AND active='Y'
	ORDER BY sum DESC"):0;

  	$discount2=(float)A::$DB->getOne("
	SELECT discount FROM {$structure}
	WHERE type='cur' AND sum<={$allsum} AND (date='N' OR (date='Y' AND date1<={$date} AND date2>={$date})) AND active='Y'
	ORDER BY sum DESC");

	$discount3=0;
	$idgroup=discount_getGroup();
	$items=A::$DB->getAll("
	SELECT discount,rules FROM {$structure}
	WHERE type='fix' AND (date='N' OR (date='Y' AND date1<={$date} AND date2>={$date})) AND active='Y'
	ORDER BY discount DESC");
	foreach($items as $row)
    if($rules=!empty($row['rules'])?unserialize($row['rules']):array())
	{ $fc=empty($rules['allcategories'])||in_array($data['idcat'],$rules['allcategories']);
	  $fg=empty($rules['groups'])||!$idgroup||in_array($idgroup,$rules['groups']);
      if($fc && $fg)
      { $discount3=(float)$row['discount'];
        break;
      }
    }

	$discount[$data['idcat']]=max($discount1,$discount2,$discount3);
  }

  if($discount[$data['idcat']])
  {
    $data['oldprice']=$data['price'];
    $data['discountpr']=$discount[$data['idcat']];
    $data['discount']=round($data['price']*$discount[$data['idcat']]/100,$dec);
	$data['price']=$data['price']-$data['discount'];

    if(!empty($data['mprices']))
    foreach($data['mprices'] as $i=>$mp)
    { $data['mprices'][$i]['oldprice']=$mp['price'];
	  $data['mprices'][$i]['discountpr']=$discount[$data['idcat']];
	  $data['mprices'][$i]['discount']=round($mp['price']*$discount[$data['idcat']]/100,$dec);
	  $data['mprices'][$i]['price']=$mp['price']-$data['mprices'][$i]['discount'];
    }
  }

  return $data;
}

A::$OBSERVER->AddModifier('shoplite_prepareValues','discount_prepareValues');