DROP TABLE IF EXISTS `{structure}`;
CREATE TABLE `{structure}` (
  `id` int(11) NOT NULL auto_increment,
  `sum` int(11) NOT NULL default '0',
  `discount` decimal(10,2) NOT NULL default '0.00',
  `type` enum('cur','all','fix','var') NOT NULL default 'cur',
  `date` enum('Y','N') NOT NULL default 'N',
  `date1` int(11) NOT NULL default '0',
  `date2` int(11) NOT NULL default '0',
  `rules` blob default NULL,
  `active` enum('Y','N') NOT NULL default 'Y',
  PRIMARY KEY  (`id`),
  KEY `sum` (`sum`),
  KEY `date1` (`date1`),
  KEY `date2` (`date2`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;